	name	pmode
code	segment	byte	public	'code'
	assume	cs:code, ds:code

	extrn	parsecl:near

	org	100h

begin:	jmp	start

help	db	'Usage:  PMode 1 | 2 | 3 | 4', 0dh, 0ah
	db	'Sets COM port to 19200, n, 8, 1', 0dh, 0ah, '$'
nosuch	db	'BIOS does not contain entry for this port.', 0dh, 0ah, '$'

biosdata dw	40h

start:	call	parsecl
	mov	bx, ax
	or	ax, ax
	jz	lbl010
	mov	bx, [bx]
	mov	bl, [bx]
	cmp	bl, '1'
	jb	lbl010
	cmp	bl, '4'
	jna	lbl020
lbl010:	mov	dx, offset help
	mov	ah, 9
	int	21h
	jmp	short lbl080			;exit with no errors

lbl020:	sub	bl, '1'
	mov	bh, 0
	shl	bx, 1

	mov	es, biosdata
	mov	dx, es:[bx]		;get com port base
	or	dx, dx
	jz	lbl070			;no such port
	add	dx, 3
	mov	al, 83h			;8, n, 1, dlab=1
	cli
	out	dx, al
	sub	dx, 3
	mov	al, 6			;19200 baud low
	out	dx, al
	inc	dx
	mov	al, 0			;19200 baud high
	out	dx, al
	inc	dx
	inc	dx			;back to base + 3
	mov	al, 3			;8, n, 1, dbab=0
	out	dx, al
	sti
	jmp	lbl080

lbl070:	mov	dx, offset nosuch
	mov	ah, 9
	int	21h
	mov	ax, 4c01h		;show error
	jmp	lbl090

lbl080:	mov	ax, 4c00h
lbl090:	int	21h			;exit with no errors

code	ends
	end	begin
