;**********************************************************
;*    EVEREX.ASP (C) 1989 DATASTORM TECHNOLOGIES, INC.    *
;*                                                        *
;*    An ASPECT script file for initializing the          *
;*    EVEREX 24E+ MODEM (with MNP/Level 5) with           *
;*    PROCOMM PLUS.                                       *
;*                                                        *
;**********************************************************

CLEAR
CUROFF
BOX 0 0 9 58 14
ATSAY 2 2 14 "PROCOMM PLUS is designed to work efficiently with the"
ATSAY 3 2 14 "EVEREX 24E+ MODEM in all its operational modes, but"
ATSAY 4 2 14 "the initial setup differs from the setup for ordinary"
ATSAY 5 2 14 "non-error-correcting modems."
ATSAY 7 2 14 "            <press ENTER to continue>"
WAIT1:
IF NOT HITKEY
   GOTO WAIT1
ENDIF
CLEAR
BOX 0 0 17 59 14
ATSAY 2 2 14 "The basic principle is that the computer-to-modem baud-"
ATSAY 3 2 14 "rate is fixed at 9600 (thus your status line will"
ATSAY 4 2 14 "*always* read 9600) and the modem itself adjusts to"
ATSAY 5 2 14 "the actual speed of the connection."
ATSAY 7 2 14 "This ASPECT file sends to the modem all the commands"
ATSAY 8 2 14 "necessary for efficient automatic use of its error-"
ATSAY 9 2 14 "correcting features. You only need to run it one time,"
ATSAY 10 2 14 "since it tells the modem to write these settings to"
ATSAY 11 2 14 "non-volatile RAM. It is also very important to follow"
ATSAY 12 2 14 "*exactly* the instructions that appear on the screen"
ATSAY 13 2 14 "as you run this file."
ATSAY 15 2 14 "                 <press ENTER to continue>"
WAIT2:
IF NOT HITKEY
   GOTO WAIT2
ENDIF
CLEAR
SOUND 440 50
BOX 0 0 4 56 14
ATSAY 2 2 14 "EVEREX 24E+ modem initialization... WORKING..."
SET BAUDRATE 9600                         ;Set up comm line
SET PARITY NONE
SET DATABITS 8
SET STOPBITS 1
SET DISPLAY OFF
SET TXPACE 100
TRANSMIT "AT^M"                           ;Get modem's attention
PAUSE 2
TRANSMIT "ATZ^M"                          ;Resets non-volatile mem
PAUSE 1
TRANSMIT "AT&F^M"                         ;Get factory defaults
PAUSE 1
TRANSMIT "AT Q0^M"                        ;Enable result codes
PAUSE 1
TRANSMIT "AT V1^M"                        ;Enable verbal result codes
PAUSE 1
TRANSMIT "AT X4^M"                        ;Enable full result codes
PAUSE 1
TRANSMIT "AT &C1^M"                       ;DCD tracks state of CD line
PAUSE 1
TRANSMIT "AT &D2^M"                       ;DTR tracks state of DTR line
PAUSE 1
TRANSMIT "AT \Q3^M"                       ;Bidirectional hardware flow control
PAUSE 1
TRANSMIT "AT \C1^M"                       ;Enable Auto-Reliable Buffer (200 char)
PAUSE 1
TRANSMIT "AT \N3^M"                       ;Auto-reliable mode on
PAUSE 1
TRANSMIT "AT \J0^M"                       ;Serial baud independent of line baud
PAUSE 1
TRANSMIT "AT \V1^M"                       ;Verbal reliable result codes
PAUSE 1
TRANSMIT "AT&W0^M"                        ;Write settings to NRAM
SET TXPACE 0
CLEAR
SET DISPLAY ON
SOUND 440 50
BOX 0 0 16 58 14
ATSAY 2 2 14 "EVEREX 24E+ modem initialization - COMPLETED!"
ATSAY 4 2 14 "Your EVEREX 24E+ will now power up with the proper"
ATSAY 5 2 14 "defaults for PROCOMM PLUS.  You should now use the"
ATSAY 6 2 14 "Setup Facility (Alt-S) MODEM OPTIONS to make your"
ATSAY 7 2 14 "INITIALIZATION COMMAND `"ATZ S7=60 S11=55^M`" (no quotes)"
ATSAY 8 2 14 "In addition AUTOBAUD DETECT should be set to OFF and"
ATSAY 9 2 14 "in TERMINAL OPTIONS Hardware Flow Control (RTS/CTS)"
ATSAY 10 2 14 "should be turned ON. All dialing directory entries"
ATSAY 11 2 14 "should be set to 9600 baud, as well as your ALT-P"
ATSAY 12 2 14 "line setting. Make sure to save your changes."
ATSAY 13 2 14 "One last thing: your CONNECT MESSAGES in MODEM OPTIONS"
ATSAY 14 2 14 "should all read simply `"CONNECT`" (without quotes)."
exit
CURON
LOCATE 17 0

